jaciv_app/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path
from django.views.generic import RedirectView

from jaciv_app import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('publications/', include('publications.urls')),
    path('admin-module/', include('admin_module.urls')),
    path('', include('users.urls')),
    path('', RedirectView.as_view(url='/welcome/')),
]

urlpatterns = urlpatterns + \
    static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns = urlpatterns + \
    static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

publications/urls.py
from django.urls import path
from publications.views import show_deals, payment_cancel, create_publication
from publications.views import get_account_publications, publication_details, delete_publication
from publications.views import change_publication_state, report_publication
from publications.views import PaypalPaymentProcess, PaypalPaymentResponse

urlpatterns = [
    path(
        'account-publications/',
        get_account_publications,
        name='account-publications',
    ),
    path(
        'change-publication-state/<uuid:pk>',
        change_publication_state,
        name='change-publication-state',
    ),
    path(
        'create-publication/',
        create_publication,
        name='create-publication',
    ),
    path(
        'deals/',
        show_deals,
        name='show-pulication-deals',
    ),
    path(
        'delete-publication',
        delete_publication,
        name='delete-publication',
    ),
    path(
        'payment-cancel/',
        payment_cancel,
        name='payment-cancel',
    ),
    path(
        'payment-done/',
        PaypalPaymentResponse.as_view(),
        name="payment-done",
    ),
    path(
        'process-payment/<int:pk>/',
        PaypalPaymentProcess.as_view(),
        name='process-payment',
    ),
    path(
        'publication-details/<uuid:pk>',
        publication_details,
        name='publication-details',
    ),
    path(
        'report-publication/<uuid:pk>/',
        report_publication,
        name='report-publication',
    ),
]

users/urls.py
from django.urls import include, path

from users.views import Signup, account_management, update_account_details, transaction_history
from users.views import welcome, search_store, view_profile, comment_profile, rate_profile
from users.views import report_profile, suggest_profile, account_suggestions, delete_suggestion
from users.views import report_comment, delete_account, filter_search, refund_transaction

urlpatterns = [
    path(
        '',
        welcome,
        name='welcome',
    ),
    path(
        'signup/',
        Signup.as_view(),
        name='signup',
    ),
    path(
        'account-management/<int:pk>/',
        account_management,
        name='account-management',
    ),
    path(
        'update-account-details/',
        update_account_details,
        name='update-account-details',
    ),
    path(
        'transactions-history/',
        transaction_history,
        name='transactions-history',
    ),
    path(
        'search-site/',
        search_store,
        name='search-site',
    ),
    path(
        'user-account/<int:pk>',
        view_profile,
        name='user-account',
    ),
    path(
        'comment-profile/<int:profile_pk>/',
        comment_profile,
        name='comment-profile',
    ),
    path(
        'filter-publications/',
        filter_search,
        name='filter-publications',
    ),
    path(
        'rate-profile/',
        rate_profile,
        name='rate-profile',
    ),
    path(
        'report-profile/<int:profile_pk>/',
        report_profile,
        name='report-profile',
    ),
    path(
        'suggest-profile/<int:profile_pk>/',
        suggest_profile,
        name='suggest-profile',
    ),
    path(
        'user-suggestions/',
        account_suggestions,
        name='user-suggestions',
    ),
    path(
        'delete-suggestion/<uuid:pk>',
        delete_suggestion,
        name='delete-suggestion',
    ),
    path(
        'report-comment/<uuid:pk>',
        report_comment,
        name='report-comment',
    ),
    path(
        'delete-account/',
        delete_account,
        name='delete-account',
    ),
    path(
        'refund-transaction/<uuid:pk>',
        refund_transaction,
        name='refund-transaction',
    ),
]

publications/models.py
import uuid
import datetime
from dateutil.relativedelta import relativedelta
from django.db import models
from django.urls import reverse

from users.models import CustomUser


class Tag(models.Model):
    id = models.UUIDField(
        primary_key=True,
        default=uuid.uuid4,
    )
    tag_name = models.CharField(
        max_length=25,
        verbose_name='etiqueta',
    )

    class Meta:
        indexes = [
            models.Index(fields=['id', ], name='tag_id_index')
        ]
        ordering = ['tag_name', ]
        verbose_name = 'etiqueta'
        verbose_name_plural = 'etiquetas'

    def __str__(self):
        return self.tag_name


class Deal(models.Model):

    publication_number = models.IntegerField(
        verbose_name='número de Publicaciones',
    )
    price = models.DecimalField(
        max_digits=6,
        decimal_places=2,
        verbose_name='precio'
    )
    deal_picture = models.ImageField(
        upload_to='images/deals_pics',
        blank=True,
        null=True,
        verbose_name='foto de Oferta',
    )

    class Meta:
        verbose_name = 'promoción'
        verbose_name_plural = 'promociones'

    def __str__(self):
        return f'# {self.publication_number} $ {self.price}'


class Publication(models.Model):

    REMOVAL_OPTIONS = (
        ('V', 'Venta'),
        ('E', 'Expiración'),
        ('O', 'Otro'),
    )

    CURRENT_STATE = (
        ('D', 'Disponible'),
        ('N', 'No Disponible'),
    )

    id = models.UUIDField(
        primary_key=True,
        default=uuid.uuid4,
    )
    product_name = models.CharField(
        max_length=35,
        verbose_name='nombre del Producto',
    )
    slug = models.CharField(
        max_length=125,
        verbose_name='descripción Corta',
    )
    product_description = models.TextField(
        max_length=500,
        verbose_name='descripción',
    )
    price = models.DecimalField(
        max_digits=6,
        decimal_places=2,
        verbose_name='precio',
    )
    photo = models.ImageField(
        upload_to='images/product_pic',
        verbose_name='foto del Producto',
        help_text='Recomendado: Utilizar imágenes horizontales'
    )
    seller = models.ForeignKey(
        CustomUser,
        on_delete=models.Case,
        blank=True,
        null=True,
        related_name='customuser_as_seller',
        verbose_name='vendedor'
    )
    tag_list = models.ManyToManyField(
        Tag,
        related_name='tag_as_publication_tag',
        verbose_name='etiquetas',
    )
    publication_date = models.DateField(
        default=datetime.datetime.now,
        verbose_name='fecha de Publicación',
    )
    removal_date = models.DateField(
        default=(datetime.date.today() + relativedelta(months=+6)),
        blank=True,
        null=True,
        verbose_name='fecha de Baja',
    )
    removal_motive = models.CharField(
        max_length=1,
        choices=REMOVAL_OPTIONS,
        default='O',
        blank=True,
        null=True,
        verbose_name='motivo de Baja'
    )
    state = models.CharField(
        max_length=1,
        choices=CURRENT_STATE,
        default='D',
        verbose_name='disponibilidad'
    )
    views = models.DecimalField(
        max_digits=12,
        decimal_places=0,
        default=0,
        blank=True,
        null=True,
        verbose_name='vistas',
    )

    class Meta:
        indexes = [
            models.Index(fields=['id', ], name='publication_id_index'),
        ]
        ordering = ['publication_date', 'seller']
        verbose_name = 'publicación'
        verbose_name_plural = 'publicaciones'

    def get_absolute_url(self):
        return reverse('publication-details', args=[str(self.id)])

    def __str__(self):
        return f'{self.product_name} ${self.price}'


class PublicationWarehouse(models.Model):
    REMOVAL_OPTIONS = (
        ('V', 'Venta'),
        ('E', 'Expiración'),
        ('O', 'Otro'),
    )

    id = models.UUIDField(
        primary_key=True,
        default=uuid.uuid4,
    )
    product_name = models.CharField(
        max_length=35,
        verbose_name='nombre del Producto',
    )
    price = models.DecimalField(
        max_digits=8,
        decimal_places=2,
        verbose_name='precio',
    )
    seller = models.ForeignKey(
        CustomUser,
        on_delete=models.SET_NULL,
        blank=True,
        null=True,
        related_name='customuser_as_seller_w',
        verbose_name='vendedor'
    )
    publication_date = models.DateField(
        default=datetime.datetime.now,
        verbose_name='fecha de Publicación',
    )
    removal_date = models.DateField(
        default=datetime.datetime.now,
        verbose_name='fecha de Baja',
    )
    active_days = models.IntegerField(
        verbose_name='diferencia de Días',
    )
    removal_motive = models.CharField(
        max_length=1,
        choices=REMOVAL_OPTIONS,
        default='O',
        verbose_name='motivo de Baja'
    )

    class Meta:
        indexes = [
            models.Index(fields=['id', ], name='publication_w_id_index'),
        ]
        ordering = ['removal_date', 'seller']
        verbose_name = 'almacén'
        verbose_name_plural = 'almacenes'

    def __str__(self):
        return f'{self.product_name} ${self.price} DIV: {self.active_days}'

publications/forms.py
from django import forms
from django.core.exceptions import ValidationError
from django.utils.translation import ugettext_lazy as _

from publications.models import Publication
from publications.utils import check_price_integrity


class BuyPublicationsForm(forms.Form):

    publication_number = forms.IntegerField(
        required=True,
    )
    price = forms.DecimalField(
        max_digits=6,
        decimal_places=2,
    )


class CreatePublicationForm(forms.ModelForm):

    tag_field = forms.CharField(
        max_length=500,
        label='Etiquetas',
        help_text='Separar las etiquetas con [,] ejemplo: microcontrolador, arduino, uno')

    class Meta:
        model = Publication
        fields = ['product_name', 'slug', 'product_description', 'price', 'photo',
                  'tag_field', ]

    def clean_price(self):
        """ Method to verify te integrity of the price  """

        data = self.cleaned_data['price']
        price_is_valid = check_price_integrity(data)

        if price_is_valid is False:
            raise ValidationError(_('Ingrese un número mayor a 0.'))

        return data


class DeletePublicationForm(forms.Form):

    REMOVAL_OPTIONS = (
        ('V', 'Venta'),
        ('E', 'Expiración'),
        ('O', 'Otro'),
    )

    uuid = forms.UUIDField()
    removal_motive = forms.ChoiceField(
        choices=REMOVAL_OPTIONS, label='Selecciona el motivo de la eliminación')

    def __init__(self, *args, **kwargs):
        super(DeletePublicationForm, self).__init__(*args, **kwargs)
        self.fields['removal_motive'].required = True
        self.fields['uuid'].required = True
        self.fields['uuid'].widget = forms.HiddenInput()

publications/templates/publications/account_publications.html
{% extends 'core.html' %} 

{% block title %}Mis Publicaciones{% endblock %} 

{% load crispy_forms_tags %}

{% block staticload %}
{% load static %} 
{% endblock %} 

{% block content %} 
{% if publications %}
  {% for publication in publications %}
  <div class="container mt-5">
            <div class="row">
                <div class="col-12 col-sm-12 col-md-3 col-lg-3 col-xl-3">
                    <a href="{{publication.get_absolute_url}}"><img class="img-thumbnail" style="max-height:250px" src="{{publication.photo.url}}"/></a>
                </div>
                <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
                    <div class="row">
                        <div class="col-12"><h4><a class="text-dark" href="{{publication.get_absolute_url}}">{{ publication.product_name }}</h4></a></div>
                    </div>
                    <div class="row">
                        <div class="col-12"><h6><em>{{ publication.slug }}</em></h6></div>
                    </div>
                    <div class="row">
                        <div class="col-12"><p class="lead">{{ publication.product_description }}</p></div>
                    </div>
                </div>
                <div class="col-12 col-sm-12 col-md-3 col-lg-3 col-xl-3">
                    <div class="row mt-5">
                        <div class="col-12"><h4 class="text-warning text-right"><strong>$ {{ publication.price }}</strong></h4></div>
                    </div>
                    <div class="row">
                        <div class="col-12"><p class="text-right">{{ publication.publication_date }}</p></div>
                    </div>                                        
                </div>
            </div>
            <hr/>
        </div>
  {% endfor %}
    {% if publications.has_other_pages %}
        <ul class="pagination">
            {% if publications.has_previous %}
                <li><a href="?page={{ publications.previous_page_number }}">&laquo;</a></li>
            {% else %}
                <li class="disabled"><span>&laquo;</span></li>
            {% endif %}
            {% for i in publications.paginator.page_range %}
                {% if publications.number == i %}
                    <li class="active"><span>{{ i }} <span class="sr-only">(current)</span></span></li>
                {% else %}
                    <li><a href="?page={{ i }}">{{ i }}</a></li>
                {% endif %}
            {% endfor %}
            {% if publications.has_next %}
                <li><a href="?page={{ publications.next_page_number }}">&raquo;</a></li>
            {% else %}
                <li class="disabled"><span>&raquo;</span></li>
            {% endif %}
        </ul>
    {% endif %}
{% else %}
  <div class="container">
    <div class="card" style="position: fixed; top: 50%; left: 50%; transform: translate(-50%, -50%);">
      <div class="card-body text-center">
        <p class="lead">Aun no has creado ninguna publicacion, que esperas ?</p>
      </div>
    </div>
  </div>
{% endif %}
{% endblock %}

{% block scriptfiles %}
{% endblock %}

publications/templates/publications/cancel_payment.html
{% extends 'core.html' %}
{% block title %}Pago cancelado{% endblock title %}

{% block content %}
<div class="container">
  <div class="card" style="position: fixed; top: 50%; left: 50%; transform: translate(-50%, -50%);">
    <div class="card-body text-center">
      <p class="lead">El pago ha sido cancelado !</p>
      <a class="btn btn-warning" href="{% url 'show-pulication-deals' %}">Volver</a>
    </div>
  </div>
</div>
{% endblock %}

publications/templates/publications/create_publication.html
{% extends 'core.html' %} 

{% block title %}Crear Publicación{% endblock %} 

{% load crispy_forms_tags %}

{% block staticload %}
{% load static %} 
{% endblock %} 

{% block content %}
{% if user.available_publications > 0 %}
<div class='container mt-5 mb-5'>
    <div class='card'>
        <div class="card-header bg-dark text-white text-center">
            Crear Publicación
        </div>
        <div class='card-body'>
            <form method="POST" action="{% url 'create-publication' %}" enctype="multipart/form-data">
                {% csrf_token %}
                <div class="row">
                    <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-4">
                        {{ form.product_name|as_crispy_field }}
                    </div>
                    <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-4">
                        {{ form.price|as_crispy_field }}
                    </div>
                    <div class="col-12 col-sm-12 col-md-12 col-lg-12 col-xl-4">
                        {{ form.photo|as_crispy_field }}
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        {{ form.slug|as_crispy_field }}
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        {{ form.product_description|as_crispy_field }}
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        {{ form.tag_field|as_crispy_field }}
                    </div>
                </div>
                <div class='row'>
                    <div class="col-12 col-sm-8 col-md-9 col-lg-9 col-xl-10">
                    </div>
                    <div class="col-12 col-sm-4 col-md-3 col-lg-3 col-xl-2">
                        <button type="submit" class="btn btn-warning">Crear Publicación</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>
{% else %}
    <div class="container">
    <div class="card" style="position: fixed; top: 50%; left: 50%; transform: translate(-50%, -50%);">
        <div class="card-body text-center">
            <p class="lead">Aun no has comprado ninguna publicacion, que esperas ?</p>
            <a class="btn btn-warning" href="{% url 'show-pulication-deals' %}">Comprar Ahora</a>
        </div>
    </div>
    </div>
{% endif %}
{% endblock %}

{% block scriptfiles %}
{% endblock %}

publications/templates/publications/process_payment.html
{% extends 'core.html' %} 

{% block title %}Promociones{% endblock %} 

{% load crispy_forms_tags %}

{% block staticload %}
{% load static %} 
{% endblock %} 

{% block content %}
<div class="container" style="position: fixed; top: 50%; left: 50%; transform: translate(-50%, -50%);">
    <div class="card text-center align-middle">
        <div class="card-header bg-dark text-white">
            Comprar Publicaciones
        </div>
        <div class="card-body">
            <div class="row">
                <div class="col-6">Cantidad: {{ deal.publication_number }}</div>
                <div class="col-6">Precio: ${{ deal.price }}</div>
            </div>
        </div>
        <div class="card-footer">
            {{ form.render }}
        </div>
    </div>
</div>  
{% endblock %}

{% block scriptfiles %}

{% endblock %}

publications/templates/publications/publication_details.html
{% extends 'core.html' %} 

{% block title %}Publicaciones{% endblock %} 

{% load crispy_forms_tags %}

{% block staticload %}
{% load static %} 
{% endblock %} 

{% block content %}
  <div class="container mt-5">
    <div class="card p-4">
      <div class="row">
        <div class="col-12 col-sm-12 col-md-3 col-lg-3 col-xl-3">
          {% if publication.photo %}
            <img class="img-thumbnail" src="{{publication.photo.url}}">
          {% else %}
          {% comment %} TODO Image replacement {% endcomment %}
          {% endif %}
        </div>
        <div class="col-12 col-sm-12 col-md-9 col-lg-9 col-xl-9 align-left">
          <div class="row">
            <div class="col-12">
              <h4 class="display-4"><a class="text-dark" href="{{publication.get_absolute_url}}">{{ publication.product_name }}</a></h4>
            </div>
          </div>
          <div class="row">
            <div class="col-12">
              <h6 class="display-6"><em>{{ publication.slug }}</em></h6>
            </div>
          </div>
          <div class="row">
            <div class="col-12">
              <p><small><strong>Publicado en: </strong>{{publication.publication_date}} <a class="text-danger" href="{% url 'report-publication' pk=publication.id %}">Reportar</a></small></p>
            </div>
          </div>
          <div class="row">
            <div class="col-12">
              <p class="text-warning lead"><strong>$ </strong>{{publication.price}}</p>
            </div>
          </div>
          <div class="row">
            <div class="col-3 col-sm-3 col-md-3 col-lg-2 col-xl-2">
              {% if publication.state == 'D' %}
              <p><span class="badge badge-success">{{publication.get_state_display}}</span></p>
              {% else %}
              <p><span class="badge badge-danger">{{publication.get_state_display}}</span></p>
              {% endif %}
            </div>
            {% if user.is_authenticated and publication.seller.id == user.id %}            
            <div class="col-7 col-sm-7 col-md-7 col-lg-9 col-xl-10 text-left">
              <a href="{% url 'change-publication-state' pk=publication.id %}">
              {% if publication.state == 'D' %}
                <span style="font-size: 1.0em; color: #dc3545;">
                  <i class="fas fa-power-off" aria-hidden="true"></i>
                </span>              
              {% else %}
                <span style="font-size: 1.0em; color: #28a745;">
                  <i class="fas fa-power-off" aria-hidden="true"></i>
                </span>
              {% endif %}              
              </a>
            </div>
            {% endif %}
          </div>
          <div class="row">
            <div class="col-12">
              <p>{{publication.product_description}}</p>
            </div>
          </div>
        </div>
      </div>
      {% if user.is_authenticated %}
      <hr class="mt-4 mb-4"/>
      <h5 class="display-5">Contacto del Vendedor</h5>
      <div class="row">
        <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
          <p class="display-5"><a class="text-dark" href="{{seller.get_absolute_url}}"><strong>Username: </strong>{{seller.username}}</a></p>
        </div>
        <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
          <p class="display-5"><a class="text-dark" href="{{seller.get_absolute_url}}"><strong>Nombre: </strong>{{seller.first_name}}  {{seller.last_name}}</a></p>
        </div>
      </div>
      <div class="row">
        <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
          <p class="display-5"><strong>Email: </strong>{{seller.email}}</p>
        </div>
        <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
          <p class="display-5"><strong>Teléfono: </strong>{{seller.mobile_phone}}</p>
        </div>
      </div>
    </div>
    {% endif %}
  </div>
  <div class="container mt-3 mb-5">
    {% if user.is_staff or user.id == publication.seller.id %}
      <button type="button" class="btn btn-danger btn-lg btn-block" data-toggle="modal" data-target="#deletePublicationModal">Eliminar</button>
    {% endif %}
  </div>
<div class="modal fade" id="deletePublicationModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
    aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title text-center" id="exampleModalLabel">Eliminar</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <form method="POST" action="{% url 'delete-publication' %}">
                <div class="modal-body">
                    {% csrf_token %}
                    <div class="row">
                        <div class="col-12">
                            {{removal_form.uuid|as_crispy_field}}
                            {{removal_form.removal_motive|as_crispy_field}}
                        </div>
                    </div>                    
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-dark" data-dismiss="modal">Cancelar</button>
                    <button type="submit" class="btn btn-danger">Eliminar</button>
                </div>
            </form>
        </div>
    </div>
</div>
{% endblock %}

{% block scriptfiles %}

{% endblock %}

publications/templates/publications/publication_search.html
{% extends 'core.html' %} 

{% block title %}Publicaciones{% endblock %} 

{% load crispy_forms_tags %}

{% block staticload %}
{% load static %} 
{% endblock %} 

{% block content %}
{% if publications %}
<div class="container mt-5 mb-5">
    <div class="container">
        <form method="POST" action="{% url 'filter-publications' %}">
            {% csrf_token %}
            {% if category and search %}
            <input type="hidden" class="form-control" name="category" value="{{category}}">
            <input type="hidden" class="form-control" name="search" value="{{search}}">
            {% endif %}
            <div class="row">
                <div class="form-group col-12 col-sm-12 col-md-3 col-lg-3 col-xl-3">                
                    <label for="inputState">Precio</label>
                        <select id="inputState" class="form-control" name="price">
                            <option>...</option>                      
                            <option>Menor a Mayor</option>
                            <option>Mayor a Menor</option>                          
                        </select>
                </div>
                <div class="form-group col-12 col-sm-12 col-md-3 col-lg-3 col-xl-3">
                    <label for="inputState">Fecha</label>
                        <select id="inputState" class="form-control" name="date">
                            <option>...</option>
                            <option>Nuevo Primero</option>
                            <option>Viejo Primero</option>
                        </select>
                </div>
                <div class="form-group col-12 col-sm-12 col-md-3 col-lg-3 col-xl-3">
                    <label for="inputState">Categoría</label>
                        <select id="inputState" class="form-control" name="tag">
                            <option>...</option>
                            {% for tag in tag_list %}
                            <option>{{tag}}</option>
                            {% endfor %}                                                                                                                                                                                      
                        </select>
                </div>            
                <div class="form-group col-12 col-sm-12 col-md-3 col-lg-3 col-xl-3 align-self-end">
                    <button type="submit" class="btn btn-warning btn-block">Filtrar</button>
                </div>                             
            </div>
        </form>
    </div>
    {% for publication in publications %}
    <div class="card">
        <div class="body p-3">
            <div class="row">
                <div class="col-12 col-sm-12 col-md-12 col-lg-3 col-xl-3">
                    <a href="{{publication.get_absolute_url}}"><img class="img-thumbnail" style="max-height:200px" src="{{publication.photo.url}}"/></a>
                </div>
                <div class="col-12 col-sm-12 col-md-12 col-lg-6 col-xl-6">
                    <div class="row">
                        <div class="col-12"><h4><a class="text-dark" href="{{publication.get_absolute_url}}">{{ publication.product_name }}</h4></a></div>
                    </div>
                    <div class="row">
                        <div class="col-12"><h6><em>{{ publication.slug }}</em></h6></div>
                    </div>
                    <div class="row">
                        <div class="col-12"><p>{{ publication.product_description }}</p></div>
                    </div>
                </div>
                <div class="col-12 col-sm-12 col-md-12 col-lg-3 col-xl-3">
                    <div class="row mt-5">
                        <div class="col-12"><h4 class="text-warning text-right"><strong>$ {{ publication.price }}</strong></h4></div>
                    </div>
                    <div class="row">
                        <div class="col-12"><p class="text-right">{{ publication.publication_date }}</p></div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12 col-sm-12 col-md-12 col-lg-12 col-xl-12 text-right">
                    {% if publication.state == 'D' %}
                    <p><span class="badge badge-success">{{publication.get_state_display}}</span></p>
                    {% else %}
                    <p></small><span class="badge badge-danger">{{publication.get_state_display}}</span></p>
                    {% endif %}
                </div>
            </div>
        </div>
    </div>
    {% endfor %}

  <!-- Pagination Container -->
  <!-- <div class='container'>
        <div class="row">
          <div class="col-12">
            {% if publications.has_other_pages %}
              <ul class="pagination">
                {% if publications.has_previous %}
                <li class="page-item"><a class="page-link" href="?page={{ publications.previous_page_number }}">Anterior</a></li>
                {% else %}
                <li class="disabled page-item"><span class="page-link">Anterior</span></li>
                {% endif %}
                {% for i in publications.paginator.page_range %}
                {% if publications.number == i %}
                <li class="active page-item"><span class="page-link">{{ i }} <span class="sr-only">(current)</span></span></li>
                {% else %}
                <li class="page-item"><a class="page-link" href="?page={{ i }}">{{ i }}</a></li>
                {% endif %}
                {% endfor %}
                {% if publications.has_next %}
                <li class="page-item"><a class="page-link" href="?page={{ publications.next_page_number }}">Siguiente</a></li>
                {% else %}
                <li class="disabled page-item"><span class="page-link">Siguiente</span></li>
                {% endif %}
            </ul>
            {% endif %}      
          </div>
        </div>
      </div> -->
      <!-- Pagination Container -->       
</div>
{% else %}
<div class="container">
    <div class="card" style="position: fixed; top: 50%; left: 50%; transform: translate(-50%, -50%);">
        <div class="card-body text-center">
            <p class="lead">No se han encontrado publicaciones con los parámetros ingresados. Vuelve a intentarlo con unos distintos!</p>
        </div>
    </div>
</div>
{% endif %}
{% endblock %}

{% block scriptfiles %}
{% endblock %}

publications/templates/publications/return_payment.html
{% extends 'core.html' %}
{% block title %}Pago completado{% endblock title %} 

{% block content %}
<div class="container">
  <div class="card" style="position: fixed; top: 50%; left: 50%; transform: translate(-50%, -50%);">
    <div class="card-body text-center">
        <p class="lead">El pago ha sido exitoso ! Ya puedes comenzar a crear publicaciones.</p>
        <a class="btn btn-warning" href="{% url 'welcome' %}">Volver</a>
    </div>
  </div>
</div>
{% endblock %}